<html>
<head>
<title>OGRE: Ogre::ProgressiveMesh Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ProgressiveMesh.html">ProgressiveMesh</a></div>
<h1>Ogre::ProgressiveMesh Class Reference</h1><!-- doxytag: class="Ogre::ProgressiveMesh" -->This class reduces the complexity of the geometry it is given.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1ProgressiveMesh-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">VertexReductionQuota</a> { <a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e37dcdea89ce8a061d707b04b74a97a3c0">VRQ_CONSTANT</a>, 
<a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e38b32f463d36c939a8202f23d91c9b31c">VRQ_PROPORTIONAL</a>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The way to derive the quota of vertices which are reduced at each LOD.  <a href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">LODFaceList</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#a5453d5f251ce2f0124cb859c3c62fb2">ProgressiveMesh</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vertexData, const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *indexData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor, takes the geometry data and index buffer.  <a href="#a5453d5f251ce2f0124cb859c3c62fb2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#85108ebfc9b9b1a255d70dee8e7f0fee">~ProgressiveMesh</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#cfe2a5f48a5fa8974d2d74d00097a3de">addExtraVertexPositionBuffer</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vertexData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Adds an extra vertex position buffer.  <a href="#cfe2a5f48a5fa8974d2d74d00097a3de"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#2a1be1aa3f7fb56f1f092a5d7727ab23">build</a> (<a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> numLevels, <a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">LODFaceList</a> *outList, <a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">VertexReductionQuota</a> quota=VRQ_PROPORTIONAL, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> reductionValue=0.5f)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds the progressive mesh with the specified number of levels.  <a href="#2a1be1aa3f7fb56f1f092a5d7727ab23"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html">PMTriangle</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#6de5d3d121da657332de44f0eda1689c">TriangleList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html">PMFaceVertex</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#b399d0958410761a3e40cc9b1ee79de0">FaceVertexList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#068c955d126c3329366627661cbf91ae">CommonVertexList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#f3cb5af29550ccd45667aa9e8c0bab19">WorstCostList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html">PMWorkingData</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#ea9592c2ce2ad3f1006b892d03135162">WorkingDataList</a></td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#70b3d964a5b85435f37c6860cd1d0ecf">addWorkingData</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vertexData, const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *indexData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for building <a class="el" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html" title="Data used to calculate the collapse costs.">PMWorkingData</a> from geometry data.  <a href="#70b3d964a5b85435f37c6860cd1d0ecf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#8e15fc4982e765beeeadc092cff68e75">initialiseEdgeCollapseCosts</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for initialising the edge collapse costs.  <a href="#8e15fc4982e765beeeadc092cff68e75"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#62752a7914b7284f274325b95fe8a956">computeEdgeCollapseCost</a> (<a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *src, <a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *dest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal calculation method for deriving a collapse cost from u to v.  <a href="#62752a7914b7284f274325b95fe8a956"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#e1b5ab9072fc602148ebc424420cd6d5">computeEdgeCostAtVertexForBuffer</a> (WorkingDataList::iterator idata, size_t vertIndex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method evaluates all collapse costs from this vertex and picks the lowest for a single buffer.  <a href="#e1b5ab9072fc602148ebc424420cd6d5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#2069cc9a67af857b72ca9a68bb1c71a9">computeEdgeCostAtVertex</a> (size_t vertIndex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method evaluates all collapse costs from this vertex for every buffer and returns the worst.  <a href="#2069cc9a67af857b72ca9a68bb1c71a9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#10ca317d81b09b5cf974e7ffd7804389">computeAllCosts</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method to compute edge collapse costs for all buffers /.  <a href="#10ca317d81b09b5cf974e7ffd7804389"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#7288cad629589059118353aade1011e8">getNextCollapser</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for getting the index of next best vertex to collapse.  <a href="#7288cad629589059118353aade1011e8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#f04ce0e1651c333c31160a5e8d31c303">bakeNewLOD</a> (<a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *pData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method builds an new LOD based on the current state.  <a href="#f04ce0e1651c333c31160a5e8d31c303"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#9a2b811d9167ab86eba08512b80af523">collapse</a> (<a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *collapser)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method, collapses vertex onto it's saved collapse target.  <a href="#9a2b811d9167ab86eba08512b80af523"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#012d243506337112390de2658194969e">dumpContents</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;log)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal debugging method.  <a href="#012d243506337112390de2658194969e"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#234adc727c7bf50b18f201b68e664e85">mpVertexData</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#d712f5fffad66a568d465b2efdf2ebd0">mpIndexData</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#b166495b3a0dc8f25d25485fa11dac0e">mCurrNumIndexes</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#45c19ccc60bca019dfcd1eb7d6c5432d">mNumCommonVertices</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ProgressiveMesh.html#ea9592c2ce2ad3f1006b892d03135162">WorkingDataList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#d657f9004aabb5932753a429061b8ed7">mWorkingData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Multiple copies, 1 per vertex buffer.  <a href="#d657f9004aabb5932753a429061b8ed7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ProgressiveMesh.html#f3cb5af29550ccd45667aa9e8c0bab19">WorstCostList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh.html#efa2fb879e0989999c893e51c529d414">mWorstCosts</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The worst collapse cost from all vertex buffers for each vertex.  <a href="#efa2fb879e0989999c893e51c529d414"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html">PMFaceVertex</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A vertex as used by a face.  <a href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html">PMTriangle</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A triangle in the progressive mesh, holds extra info like face normal.  <a href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A vertex in the progressive mesh, holds info like collapse cost etc.  <a href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html">PMWorkingData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Data used to calculate the collapse costs.  <a href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class reduces the complexity of the geometry it is given. 
<p>
This class is dedicated to reducing the number of triangles in a given mesh taking into account seams in both geometry and texture co-ordinates and meshes which have multiple frames. <dl class="user" compact><dt><b></b></dt><dd>The primary use for this is generating LOD versions of <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> objects, but it can be used by any geometry provider. The only limitation at the moment is that the provider uses a common vertex buffer for all LODs and one index buffer per LOD. Therefore at the moment this class can only handle indexed geometry. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>NB the interface of this class will certainly change when compiled vertex buffers are supported. </dd></dl>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00059">59</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="0c7f783f655c0691de3ac4a30ac13db2"></a><!-- doxytag: member="Ogre::ProgressiveMesh::LODFaceList" ref="0c7f783f655c0691de3ac4a30ac13db2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1IndexData.html">IndexData</a>*&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">Ogre::ProgressiveMesh::LODFaceList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00072">72</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="6de5d3d121da657332de44f0eda1689c"></a><!-- doxytag: member="Ogre::ProgressiveMesh::TriangleList" ref="6de5d3d121da657332de44f0eda1689c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html">PMTriangle</a>&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#6de5d3d121da657332de44f0eda1689c">Ogre::ProgressiveMesh::TriangleList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00185">185</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b399d0958410761a3e40cc9b1ee79de0"></a><!-- doxytag: member="Ogre::ProgressiveMesh::FaceVertexList" ref="b399d0958410761a3e40cc9b1ee79de0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html">PMFaceVertex</a>&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#b399d0958410761a3e40cc9b1ee79de0">Ogre::ProgressiveMesh::FaceVertexList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00186">186</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="068c955d126c3329366627661cbf91ae"></a><!-- doxytag: member="Ogre::ProgressiveMesh::CommonVertexList" ref="068c955d126c3329366627661cbf91ae" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a>&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#068c955d126c3329366627661cbf91ae">Ogre::ProgressiveMesh::CommonVertexList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00187">187</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f3cb5af29550ccd45667aa9e8c0bab19"></a><!-- doxytag: member="Ogre::ProgressiveMesh::WorstCostList" ref="f3cb5af29550ccd45667aa9e8c0bab19" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#f3cb5af29550ccd45667aa9e8c0bab19">Ogre::ProgressiveMesh::WorstCostList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00188">188</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ea9592c2ce2ad3f1006b892d03135162"></a><!-- doxytag: member="Ogre::ProgressiveMesh::WorkingDataList" ref="ea9592c2ce2ad3f1006b892d03135162" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html">PMWorkingData</a>&gt; <a class="el" href="classOgre_1_1ProgressiveMesh.html#ea9592c2ce2ad3f1006b892d03135162">Ogre::ProgressiveMesh::WorkingDataList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00198">198</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="c8ade932d6a3a6b24c7b7ad33c32a8e3"></a><!-- doxytag: member="Ogre::ProgressiveMesh::VertexReductionQuota" ref="c8ade932d6a3a6b24c7b7ad33c32a8e3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">Ogre::ProgressiveMesh::VertexReductionQuota</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The way to derive the quota of vertices which are reduced at each LOD. 
<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="c8ade932d6a3a6b24c7b7ad33c32a8e37dcdea89ce8a061d707b04b74a97a3c0"></a><!-- doxytag: member="VRQ_CONSTANT" ref="c8ade932d6a3a6b24c7b7ad33c32a8e37dcdea89ce8a061d707b04b74a97a3c0" args="" -->VRQ_CONSTANT</em>&nbsp;</td><td>
A set number of vertices are removed at each reduction. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="c8ade932d6a3a6b24c7b7ad33c32a8e38b32f463d36c939a8202f23d91c9b31c"></a><!-- doxytag: member="VRQ_PROPORTIONAL" ref="c8ade932d6a3a6b24c7b7ad33c32a8e38b32f463d36c939a8202f23d91c9b31c" args="" -->VRQ_PROPORTIONAL</em>&nbsp;</td><td>
A proportion of the remaining number of vertices are removed at each reduction. </td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00064">64</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="a5453d5f251ce2f0124cb859c3c62fb2"></a><!-- doxytag: member="Ogre::ProgressiveMesh::ProgressiveMesh" ref="a5453d5f251ce2f0124cb859c3c62fb2" args="(const VertexData *vertexData, const IndexData *indexData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ProgressiveMesh::ProgressiveMesh           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>vertexData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td>
          <td class="paramname"> <em>indexData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, takes the geometry data and index buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>DO NOT pass write-only, unshadowed buffers to this method! They will not work. <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a> only shadowed buffers, or better yet perform mesh reduction as an offline process using <a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">DefaultHardwareBufferManager</a> to manage vertex buffers in system memory. </dd></dl>

</div>
</div><p>
<a class="anchor" name="85108ebfc9b9b1a255d70dee8e7f0fee"></a><!-- doxytag: member="Ogre::ProgressiveMesh::~ProgressiveMesh" ref="85108ebfc9b9b1a255d70dee8e7f0fee" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::ProgressiveMesh::~ProgressiveMesh           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="cfe2a5f48a5fa8974d2d74d00097a3de"></a><!-- doxytag: member="Ogre::ProgressiveMesh::addExtraVertexPositionBuffer" ref="cfe2a5f48a5fa8974d2d74d00097a3de" args="(const VertexData *vertexData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ProgressiveMesh::addExtraVertexPositionBuffer           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>vertexData</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Adds an extra vertex position buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>As well as the main vertex buffer, the client of this class may add extra versions of the vertex buffer which will also be taken into account when the cost of simplifying the mesh is taken into account. This is because the cost of simplifying an animated mesh cannot be calculated from just the reference position, multiple positions needs to be assessed in order to find the best simplification option. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>DO NOT pass write-only, unshadowed buffers to this method! They will not work. <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a> only shadowed buffers, or better yet perform mesh reduction as an offline process using <a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">DefaultHardwareBufferManager</a> to manage vertex buffers in system memory. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>buffer</em>&nbsp;</td><td>Pointer to x/y/z buffer with vertex positions. The number of vertices must be the same as in the original GeometryData passed to the constructor. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2a1be1aa3f7fb56f1f092a5d7727ab23"></a><!-- doxytag: member="Ogre::ProgressiveMesh::build" ref="2a1be1aa3f7fb56f1f092a5d7727ab23" args="(ushort numLevels, LODFaceList *outList, VertexReductionQuota quota=VRQ_PROPORTIONAL, Real reductionValue=0.5f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ProgressiveMesh::build           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&nbsp;</td>
          <td class="paramname"> <em>numLevels</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">LODFaceList</a> *&nbsp;</td>
          <td class="paramname"> <em>outList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">VertexReductionQuota</a>&nbsp;</td>
          <td class="paramname"> <em>quota</em> = <code>VRQ_PROPORTIONAL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>reductionValue</em> = <code>0.5f</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds the progressive mesh with the specified number of levels. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>numLevels</em>&nbsp;</td><td>The number of levels to include in the output excluding the full detail version. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>outList</em>&nbsp;</td><td>Pointer to a list of LOD geometry data which will be completed by the application. Each entry is a reduced form of the mesh, in decreasing order of detail. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>quota</em>&nbsp;</td><td>The way to derive the number of vertices removed at each LOD </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>reductionValue</em>&nbsp;</td><td>Either the proportion of vertices to remove at each level, or a fixed number of vertices to remove at each level, depending on the value of quota </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="70b3d964a5b85435f37c6860cd1d0ecf"></a><!-- doxytag: member="Ogre::ProgressiveMesh::addWorkingData" ref="70b3d964a5b85435f37c6860cd1d0ecf" args="(const VertexData *vertexData, const IndexData *indexData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::addWorkingData           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>vertexData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td>
          <td class="paramname"> <em>indexData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for building <a class="el" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html" title="Data used to calculate the collapse costs.">PMWorkingData</a> from geometry data. 
<p>

</div>
</div><p>
<a class="anchor" name="8e15fc4982e765beeeadc092cff68e75"></a><!-- doxytag: member="Ogre::ProgressiveMesh::initialiseEdgeCollapseCosts" ref="8e15fc4982e765beeeadc092cff68e75" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::initialiseEdgeCollapseCosts           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for initialising the edge collapse costs. 
<p>

</div>
</div><p>
<a class="anchor" name="62752a7914b7284f274325b95fe8a956"></a><!-- doxytag: member="Ogre::ProgressiveMesh::computeEdgeCollapseCost" ref="62752a7914b7284f274325b95fe8a956" args="(PMVertex *src, PMVertex *dest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ProgressiveMesh::computeEdgeCollapseCost           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *&nbsp;</td>
          <td class="paramname"> <em>dest</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal calculation method for deriving a collapse cost from u to v. 
<p>

</div>
</div><p>
<a class="anchor" name="e1b5ab9072fc602148ebc424420cd6d5"></a><!-- doxytag: member="Ogre::ProgressiveMesh::computeEdgeCostAtVertexForBuffer" ref="e1b5ab9072fc602148ebc424420cd6d5" args="(WorkingDataList::iterator idata, size_t vertIndex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ProgressiveMesh::computeEdgeCostAtVertexForBuffer           </td>
          <td>(</td>
          <td class="paramtype">WorkingDataList::iterator&nbsp;</td>
          <td class="paramname"> <em>idata</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertIndex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method evaluates all collapse costs from this vertex and picks the lowest for a single buffer. 
<p>

</div>
</div><p>
<a class="anchor" name="2069cc9a67af857b72ca9a68bb1c71a9"></a><!-- doxytag: member="Ogre::ProgressiveMesh::computeEdgeCostAtVertex" ref="2069cc9a67af857b72ca9a68bb1c71a9" args="(size_t vertIndex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::computeEdgeCostAtVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertIndex</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method evaluates all collapse costs from this vertex for every buffer and returns the worst. 
<p>

</div>
</div><p>
<a class="anchor" name="10ca317d81b09b5cf974e7ffd7804389"></a><!-- doxytag: member="Ogre::ProgressiveMesh::computeAllCosts" ref="10ca317d81b09b5cf974e7ffd7804389" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::computeAllCosts           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method to compute edge collapse costs for all buffers /. 
<p>

</div>
</div><p>
<a class="anchor" name="7288cad629589059118353aade1011e8"></a><!-- doxytag: member="Ogre::ProgressiveMesh::getNextCollapser" ref="7288cad629589059118353aade1011e8" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::ProgressiveMesh::getNextCollapser           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for getting the index of next best vertex to collapse. 
<p>

</div>
</div><p>
<a class="anchor" name="f04ce0e1651c333c31160a5e8d31c303"></a><!-- doxytag: member="Ogre::ProgressiveMesh::bakeNewLOD" ref="f04ce0e1651c333c31160a5e8d31c303" args="(IndexData *pData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::bakeNewLOD           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td>
          <td class="paramname"> <em>pData</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method builds an new LOD based on the current state. 
<p>

</div>
</div><p>
<a class="anchor" name="9a2b811d9167ab86eba08512b80af523"></a><!-- doxytag: member="Ogre::ProgressiveMesh::collapse" ref="9a2b811d9167ab86eba08512b80af523" args="(PMVertex *collapser)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::collapse           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">PMVertex</a> *&nbsp;</td>
          <td class="paramname"> <em>collapser</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method, collapses vertex onto it's saved collapse target. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This updates the working triangle list to drop a triangle and recalculates the edge collapse costs around the collapse target. This also updates all the working vertex lists for the relevant buffer. </dd></dl>

</div>
</div><p>
<a class="anchor" name="012d243506337112390de2658194969e"></a><!-- doxytag: member="Ogre::ProgressiveMesh::dumpContents" ref="012d243506337112390de2658194969e" args="(const String &amp;log)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ProgressiveMesh::dumpContents           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>log</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal debugging method. 
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="234adc727c7bf50b18f201b68e664e85"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mpVertexData" ref="234adc727c7bf50b18f201b68e664e85" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1ProgressiveMesh.html#234adc727c7bf50b18f201b68e664e85">Ogre::ProgressiveMesh::mpVertexData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00113">113</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d712f5fffad66a568d465b2efdf2ebd0"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mpIndexData" ref="d712f5fffad66a568d465b2efdf2ebd0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a>* <a class="el" href="classOgre_1_1ProgressiveMesh.html#d712f5fffad66a568d465b2efdf2ebd0">Ogre::ProgressiveMesh::mpIndexData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00114">114</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b166495b3a0dc8f25d25485fa11dac0e"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mCurrNumIndexes" ref="b166495b3a0dc8f25d25485fa11dac0e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1ProgressiveMesh.html#b166495b3a0dc8f25d25485fa11dac0e">Ogre::ProgressiveMesh::mCurrNumIndexes</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00116">116</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="45c19ccc60bca019dfcd1eb7d6c5432d"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mNumCommonVertices" ref="45c19ccc60bca019dfcd1eb7d6c5432d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1ProgressiveMesh.html#45c19ccc60bca019dfcd1eb7d6c5432d">Ogre::ProgressiveMesh::mNumCommonVertices</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00117">117</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d657f9004aabb5932753a429061b8ed7"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mWorkingData" ref="d657f9004aabb5932753a429061b8ed7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ProgressiveMesh.html#ea9592c2ce2ad3f1006b892d03135162">WorkingDataList</a> <a class="el" href="classOgre_1_1ProgressiveMesh.html#d657f9004aabb5932753a429061b8ed7">Ogre::ProgressiveMesh::mWorkingData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Multiple copies, 1 per vertex buffer. 
<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00200">200</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="efa2fb879e0989999c893e51c529d414"></a><!-- doxytag: member="Ogre::ProgressiveMesh::mWorstCosts" ref="efa2fb879e0989999c893e51c529d414" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ProgressiveMesh.html#f3cb5af29550ccd45667aa9e8c0bab19">WorstCostList</a> <a class="el" href="classOgre_1_1ProgressiveMesh.html#efa2fb879e0989999c893e51c529d414">Ogre::ProgressiveMesh::mWorstCosts</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The worst collapse cost from all vertex buffers for each vertex. 
<p>

<p>Definition at line <a class="el" href="OgreProgressiveMesh_8h-source.html#l00203">203</a> of file <a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreProgressiveMesh_8h-source.html">OgreProgressiveMesh.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:55 2008
</p>
</body>
</html>
